#include <stdlib.h>
#include <stdio.h>

int ProcOneLine(char*,FILE*);
#define MAXLINELEN 2048
char LineBuf[MAXLINELEN];
char StartUpMessage[]={"Patch file maker v0.1 by Bo Yang"};
int main(int argc,char**argv)
{FILE*lstf,*patf;
 int PatCnt=0;

 puts(StartUpMessage);
 if (argc<3)  { puts("usage: makepatf list-file patch-file"); return(1); }
 lstf=fopen(argv[1],"rt");
 if (lstf==NULL) { puts("can't open list-file"); return(2); }
 patf=fopen(argv[2],"wb");
 if (patf==NULL) { fclose(lstf); puts("can't open patch-file"); return(3); }
 fputc(0,patf); fputc(0,patf);
 while (1) {
   fgets(LineBuf,256,lstf);
   if (LineBuf[0]=='<') break;
   PatCnt+=ProcOneLine(LineBuf,patf);
 }
 fseek(patf,0L,0);
 fputc(PatCnt&255,patf); fputc((PatCnt>>8)&255,patf);
 fclose(patf); fclose(lstf);
}
long LastSize=0,LastOffset=0;
int ProcOneLine(char*linedat,FILE*outf)
{char fname[256];
 FILE*inf;
 long inskip,cpsize,cp2offset,smul;
//filename, start offset in file, size, offset in target
 sscanf(linedat,"%s %ld %ld %ld %ld",
                fname,&inskip,&cpsize,&smul,&cp2offset);
 cpsize*=smul;
 inf=fopen(fname,"rb");
 if (inf==NULL) return(0);
 fseek(inf,inskip,0);
 if (cp2offset==-1L) cp2offset=LastOffset+LastSize;
 LastSize=cpsize; LastOffset=cp2offset;
 fwrite((char*)&cp2offset,1,4,outf);
 fwrite((char*)&cpsize,1,4,outf);
 while (cpsize>=MAXLINELEN) {
   fread(LineBuf,MAXLINELEN,1,inf);
   fwrite(LineBuf,MAXLINELEN,1,outf);
   cpsize-=MAXLINELEN;
 }
 if (cpsize) {
   fread(LineBuf,(int)cpsize,1,inf);
   fwrite(LineBuf,(int)cpsize,1,outf);
 }
 fclose(inf); return(1);
}
